<?php
/*
  $Id: paypal.php,v 1.39 2003/01/29 19:57:15 hpdl Exp $
  modified by gregbaboolal@yahoo.com 2003/12/31

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  class paypal {
    var $code, $title, $description, $enabled;

// class constructor
    function paypal() {
      global $order;

      $this->code = 'paypal';
      $this->title = MODULE_PAYMENT_PAYPAL_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_PAYPAL_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_PAYPAL_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_PAYPAL_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_PAYPAL_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_PAYPAL_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      $this->form_action_url = 'https://www.paypal.com/cgi-bin/webscr';
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAYPAL_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYPAL_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
      global $order, $currencies, $currency;

      if (MODULE_PAYMENT_PAYPAL_CURRENCY == 'Selected Currency') {
        $my_currency = $currency;
      } else {
        $my_currency = substr(MODULE_PAYMENT_PAYPAL_CURRENCY, 5);
      }
      if (!in_array($my_currency, array('CAD', 'EUR', 'GBP', 'JPY', 'USD'))) {
        $my_currency = 'USD';
      }
      return $this->_getPayPalFields($order, $currencies,$my_currency);
    }

    function before_process() {
      global $cart, $customer_id, $order;
      include_once DIR_WS_CLASSES.'/paypal/ipn.php';
      if ( strcmp(phpversion(),'4.0.6') <= 0 ) $_POST = $HTTP_POST_VARS;
      $ipn = new paypal_ipn(MODULE_PAYMENT_PAYPAL_IPN_DEBUG_EMAIL,$_POST,tep_session_name(),MODULE_PAYMENT_PAYPAL_IPN_DEBUG);
      //post back to PayPal system to validate
      if($ipn->authenticate('www.paypal.com')) {
        //check to see whether the txn_id already exists
        if(!$ipn->unique_txn_id()) {
          //txn_id has already been stored, so reset shopping cart session
          $cart->reset(true);
          // unregister session variables used during checkout
          tep_session_unregister('sendto');
          tep_session_unregister('billto');
          tep_session_unregister('shipping');
          tep_session_unregister('payment');
          tep_session_unregister('comments');
          tep_redirect(tep_href_link(FILENAME_CHECKOUT_SUCCESS, 'paypal=authorized', 'SSL'));
        } else {
          //PayPal hasn't notified us yet but the customer is here, so continue the transaction.
          //Really we could do further checks like checking for
          //a valid payment i.e. $ipn_cart->valid_payment($ipn,$cart,$currency)
          $ipn->insert_ipn_txn();
          $order->paypal_ipn_id = $ipn->get_paypal_ipn_id();
          return false;
        }
      } else {
        //PayPal did not authorize this transaction or there may have been problems
        //communicating with them, If there were no communication problems then someone is
        //trying a blatant hack, so send the store owner msg to that effect and let the
        //them continue as per default osC scenario
        $msg = "A transaction occured but PayPal did not verify it, this could be due to a "
               ."communications error, but it could also be an attempted hack.\r\n"
               ."Customer $customer_id, {$order->customer['firstname']} {$order->customer['lastname']} has been "
               ."allowed to continue their order.\r\n"
               ."Please Check Your PayPal account.\r\n\r\n";
        $ipn->send_email('Invalid Customer Transaction',$msg);
        unset($msg);
        return false;
      }
    }

    function after_process() {
      return false;
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYPAL_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable PayPal Module', 'MODULE_PAYMENT_PAYPAL_STATUS', 'True', 'Do you want to accept PayPal payments?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('E-Mail Address', 'MODULE_PAYMENT_PAYPAL_ID','".STORE_OWNER_EMAIL_ADDRESS."', 'The e-mail address to use for the PayPal service', '6', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Business Name', 'MODULE_PAYMENT_PAYPAL_BUSINESS_ID','".STORE_OWNER_EMAIL_ADDRESS."', 'Email address or account ID of the payment recipient', '6', '3', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Currency', 'MODULE_PAYMENT_PAYPAL_CURRENCY', 'Selected Currency', 'The currency to use for credit card transactions', '6', '4', 'tep_cfg_select_option(array(\'Selected Currency\',\'Only USD\',\'Only CAD\',\'Only EUR\',\'Only GBP\',\'Only JPY\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_PAYPAL_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '5', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_PAYPAL_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '6', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_PAYPAL_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '7', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Background Color', 'MODULE_PAYMENT_PAYPAL_CS', '0', 'Select the background color of PayPal\'s payment pages.<br>0=White, 1=Black', '6', '8', 'tep_cfg_select_option(array(\'0\',\'1\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Store Logo', 'MODULE_PAYMENT_PAYPAL_STORE_LOGO_ENABLED', '1', 'If you do not have SSL then set to 0.<br>0 = No, 1 = Yes', '6', '9', 'tep_cfg_select_option(array(\'0\',\'1\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Store logo', 'MODULE_PAYMENT_PAYPAL_STORE_LOGO_IMAGE_NAME', 'oscommerce.gif', 'The image file name for PayPal to display', '6', '10', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Include a note with payment', 'MODULE_PAYMENT_PAYPAL_NO_NOTE', '0', 'Choose whether your customer should be prompted to include a note or not?<br>0=Yes, 1=No', '6', '11', 'tep_cfg_select_option(array(\'0\',\'1\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Return URL behavior', 'MODULE_PAYMENT_PAYPAL_RM', '2', 'How should the customer be sent back from PayPal to the specified URL?<br>0=No IPN, 1=GET, 2=POST', '6', '12', 'tep_cfg_select_option(array(\'0\',\'1\',\'2\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Shopping Cart Method', 'MODULE_PAYMENT_PAYPAL_METHOD', '1', 'What type of shopping cart do you want to use?<br>1=Aggregate, 2=Itemized', '6', '13', 'tep_cfg_select_option(array(\'1\',\'2\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Email Notifications', 'MODULE_PAYMENT_PAYPAL_IPN_DEBUG', '2', 'The email notification level<br>(1 is recommended)', '6', '14', 'tep_cfg_select_option(array(\'0\',\'1\',\'2\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Test Mode', 'MODULE_PAYMENT_PAYPAL_IPN_DEBUG_TEST', '0', '0 = Off, 1 = On', '6', '15', 'tep_cfg_select_option(array(\'0\',\'1\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Notification Address', 'MODULE_PAYMENT_PAYPAL_IPN_DEBUG_EMAIL','".STORE_OWNER_EMAIL_ADDRESS."', 'The e-mail address to send (level 1) notifications to', '6', '16', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_PAYPAL_STATUS', 'MODULE_PAYMENT_PAYPAL_ID', 'MODULE_PAYMENT_PAYPAL_BUSINESS_ID', 'MODULE_PAYMENT_PAYPAL_CURRENCY', 'MODULE_PAYMENT_PAYPAL_ZONE', 'MODULE_PAYMENT_PAYPAL_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAYPAL_SORT_ORDER','MODULE_PAYMENT_PAYPAL_CS', 'MODULE_PAYMENT_PAYPAL_STORE_LOGO_ENABLED', 'MODULE_PAYMENT_PAYPAL_STORE_LOGO_IMAGE_NAME', 'MODULE_PAYMENT_PAYPAL_NO_NOTE', 'MODULE_PAYMENT_PAYPAL_METHOD', 'MODULE_PAYMENT_PAYPAL_IPN_DEBUG','MODULE_PAYMENT_PAYPAL_IPN_DEBUG_TEST','MODULE_PAYMENT_PAYPAL_IPN_DEBUG_EMAIL');
    }

    function _getPayPalFields(&$order, &$currencies, $my_currency) {

      $paypal_fields .= tep_draw_hidden_field('cmd', '_ext-enter') . //allows the customer addr details to be passed
      tep_draw_hidden_field('business', MODULE_PAYMENT_PAYPAL_BUSINESS_ID) ;
      if(MODULE_PAYMENT_PAYPAL_STORE_LOGO_ENABLED) $paypal_fields .= tep_draw_hidden_field('image_url', tep_href_link(DIR_WS_IMAGES.MODULE_PAYMENT_PAYPAL_STORE_LOGO_IMAGE_NAME, '', 'SSL')) ;
      $paypal_fields .= tep_draw_hidden_field('return', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL')) .
      tep_draw_hidden_field('cancel_return', tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL')) ;

      if(MODULE_PAYMENT_PAYPAL_METHOD == 2) {

        $paypal_fields .= tep_draw_hidden_field('upload', sizeof($order->products) ) .
        tep_draw_hidden_field('redirect_cmd', '_cart') .
        tep_draw_hidden_field('handling_cart', number_format($order->info['shipping_cost'] * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency)));
        //Let PayPal Calculate the amount since we're essentiall uploading a shopping cart
        //tep_draw_hidden_field('amount', number_format(($order->info['total'] - $order->info['shipping_cost']) * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency)));

      } else {

        $paypal_fields .= tep_draw_hidden_field('item_name', STORE_NAME) .
        tep_draw_hidden_field('redirect_cmd', '_xclick') .
        tep_draw_hidden_field('amount', number_format(($order->info['total'] - $order->info['shipping_cost']) * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency))) .
        tep_draw_hidden_field('shipping', number_format($order->info['shipping_cost'] * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency)));

      }

      //See Manual: 0= No IPN, 1 = GET, 2 = POST
      $paypal_fields .= tep_draw_hidden_field('rm', MODULE_PAYMENT_PAYPAL_RM) .
      tep_draw_hidden_field('cancel_return', tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL')) .
      tep_draw_hidden_field( 'custom', tep_session_id() ) .

      tep_draw_hidden_field('currency_code', $my_currency) .

      $this->_drawCustomerDetails($order) .

      //Customer comment field - defualt 'yes'
      $this->_drawNoteOption(MODULE_PAYMENT_PAYPAL_NO_NOTE , MODULE_PAYMENT_PAYPAL_CUSTOMER_COMMENTS) .

      //PayPal Background Color
      tep_draw_hidden_field('cs',MODULE_PAYMENT_PAYPAL_CS);

      if(MODULE_PAYMENT_PAYPAL_METHOD == 2) {
        //Customer Order Details
        for ($i=0; $i<sizeof($order->products); $i++) {
          $index = $i+1;
          $paypal_fields .= tep_draw_hidden_field('item_name_'.$index, $order->products[$i]['name']).
          tep_draw_hidden_field('item_number_'.$index, $order->products[$i]['model']).
          tep_draw_hidden_field('quantity_'.$index, $order->products[$i]['qty']).
          tep_draw_hidden_field('amount_'.$index, number_format($order->products[$i]['final_price']* $currencies->get_value($my_currency),2));
          $paypal_fields .= tep_draw_hidden_field('tax_'.$index, number_format($order->info['tax'] * $currencies->get_value($my_currency),2));
          //Customer Specified Product Options: PayPal Max = 2
          if ($order->products[$i]['attributes']) {
            for ($j=0, $n=sizeof($order->products[$i]['attributes']); $j<2; $j++) {
              if($order->products[$i]['attributes'][$j]['option']){
                $paypal_fields .= $this->_drawPayPalOptionSet($j,$index,$order->products[$i]['attributes'][$j]['option'],$order->products[$i]['attributes'][$j]['value']);
              } else {
                $paypal_fields .= $this->_drawPayPalOptionSet($j,$index,' ',' ');
              }
            }
          } else {
            for ($j=0; $j<2; $j++) {
              $paypal_fields .= $this->_drawPayPalOptionSet($j,$index,' ',' ');
            }
          }
        }
      } else { //method 1
        $item_number;
        for ($i=0; $i<sizeof($order->products); $i++) {
          $item_number .= ' '.$order->products[$i]['name'].' ,';
        }
        $item_number = substr_replace($item_number,'',-1);
        $paypal_fields .= tep_draw_hidden_field('item_number', $item_number);
      }
      return $paypal_fields;
    }

    function _drawCustomerDetails(&$order) {
      //Customer Details - for those who haven't signed up to PayPal
      //Telephone is problematic so left out for now.
      $paypal_fields = tep_draw_hidden_field('email', $order->customer['email_address']) .
      tep_draw_hidden_field('ghost', $order->customer['ghost']) .
      tep_draw_hidden_field('first_name', $order->customer['firstname']) .
      tep_draw_hidden_field('last_name', $order->customer['lastname']) .
      tep_draw_hidden_field('address1', $order->customer['street_address']) .
      tep_draw_hidden_field('address2', '') .
      tep_draw_hidden_field('city', $order->customer['city']) .
      tep_draw_hidden_field('state', tep_get_zone_code($order->customer['country']['id'],$order->customer['zone_id'],$order->customer['zone_id'])) .
      tep_draw_hidden_field('zip', $order->customer['postcode']);
      //User Country Preference
      //Note: Anguilla[AI], Dominican Republic[DO], The Netherlands[NL] have different codes to the iso codes in the osC db
      $paypal_fields .= tep_draw_hidden_field('lc', $order->customer['country']['iso_code_2']);
      return $paypal_fields;
    }

    function _drawPayPalOptionSet($sub_index,$index,$option=' ',$value=' ') {
        return tep_draw_hidden_field('on'.$sub_index.'_'.$index,$option).
          tep_draw_hidden_field('os'.$sub_index.'_'.$index,$value);
    }

    function _drawNoteOption($option='1',$msg='Add Comments About Your Order') {
      $no_note = tep_draw_hidden_field('no_note',$option);
      if (!$option) return $no_note .= tep_draw_hidden_field('cn',$msg);
      else return $no_note;;
    }

  }
?>
