<?php
/*
  $Id: worldpay.php,v 1.1 2003/10/16 21:13:23 webot Exp $
  Author : Graeme Simms (gsimms@icon.co.za)
  Title: WorldPay Payment Module V4.0 Beta

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2002 osCommerce

  Released under the GNU General Public License
  
  This is an updated WorldPay module based on all prior contributions by, and not limited to  Stuart Cutting, Ian Davidson, Robert N Wood, Mark Keith Evans, Brian Kiggin, Neil Millard, the authorizenet.php, secpay.php and paypal.php modules included in OSC 2.2 CVS 25 Dec 2002.  All creadit to those authors, especially Ian and David for all the work they've done in the forums as well.
    
  I've almost re-written this module from scratch, trying to make it easier to understand with comments and to make it work with OSC 2.2 CVS snapshot dated 25 Dec 2002.  Prior versions of the module were not compatible with the updated OSCommerce routines, requiring complex workarounds.
  
  Please note : This has not been tested in a live environment.  Why then have I done this?    I came across OSCommerce a week ago, and being in South Africa, WorldPay is the only gateway I can use here as a Trader not having a merchant account.
  
  I wanted to make sure that before I implemented the store for myself, that it would work with Worldpay.  After spending much time dissecting code and teaching myself how it all works, I got round to implementing V3 of the Worldpay module, only to find the solution wasn't entirely perfect, due to not making use of Worldpay's Callback feature.
  
  I think I have managed to get it working in this module.  I'm not a WorldPay customer, and as such am releasing this module as BETA in the hopes that programmers who are more clued up than I am can make use of this module and clean / fix it and re-release it as a contribution that is stable and that works in a live environment.
  
 Feel free to contact me at my e-mail address above if you have any comments.

 Updates from v3 :
 
 - Better Admin Control - you can now turn on/off MD5 and the pre-auth functions
 - Commented code to make things easier to grasp!!!
 - Designed to use callback facility from WorldPay - probably only works this way.

 All the best, Graeme Simms. 
  
*/

  class worldpay {
    var $code, $title, $description, $enabled;

// class constructor
    function worldpay() {
      $this->code = 'worldpay';
      $this->title = MODULE_PAYMENT_WORLDPAY_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_WORLDPAY_TEXT_DESCRIPTION;
      $this->enabled = ((MODULE_PAYMENT_WORLDPAY_STATUS == 'True') ? true : false);
// The line below is the URL to submit payments to, should be
// https://select.worldpay.com/wcc/purchase
      $this->form_action_url = 'https://select.worldpay.com/wcc/purchase';
    }

// class methods
    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
// I don't know if all these variables are neccessary? 
       global $HTTP_POST_VARS, $shipping_cost, $total_cost, $shipping_selected, $shipping_method, $currencies, $currency, $customer_id , $order;
// The lines below create strings that include the session name and id, as well as a variables - you will see shipping_selected is common to both - for some reason, if this is not there, the checkout asks you to select another payment method.  Even if the shipping variables are empty when returned.  I can't see why the success string needs additional variables, but in my limited testing it only worked this way.
      $worldpay_fail = tep_session_name() . '=' . tep_session_id() . '&shipping_selected=' . $shipping_selected;
	  $worldpay_success = tep_session_name() . '=' . tep_session_id() . '&shipping_selected=' . $shipping_selected . '&shipping_cost=' . $shipping_cost . '&shipping_method=' . urlencode($shipping_method);
// The process_button_string contains the form that is sent to Worldpay.	  
    $process_button_string = 
// The following first five fields are compulsory for WorldPay.
// Selects the WorldPay ID as specified in Admin	
	tep_draw_hidden_field('instId', MODULE_PAYMENT_WORLDPAY_ID) .
	tep_draw_hidden_field('currency', $currency) . 
// Displays "Purchase from StoreName" on the WorldPay screen for the customer.  You may want to modify this
	 tep_draw_hidden_field('desc', 'Purchase from '.STORE_NAME) .                    		
// Thought it would be nice to add the Customer Name to the cartId field.  The following code creates the string : "Store Name : FirstName LastName"  I think this gets reflected on statements.
	 tep_draw_hidden_field('cartId', STORE_NAME.' : '.$order->customer['firstname'].' '.$order->customer['lastname']) .
//Modified the number format function to remove the thousand comma.  The effective commands are : value, 2 decimal places, a . for the decimal indicator, no thousand indicater.  Without this modification, any amount above 999.99 was arriving as 1,000.99 which does not look compatible to WorldPay as per their docs.
	 tep_draw_hidden_field('amount', number_format($order->info['total'],2,'.',''));		 
// Begin Optional Fields
// The Following lines check if you want to use PreAuth (Check WorldPay for details).  This setting is specified in Admin.  If PreAuth is on, it adds the required fields, otherwise these lines get ignored.
 	if (MODULE_PAYMENT_WORLDPAY_USEPREAUTH == 'True')  $process_button_string .= tep_draw_hidden_field('authMode', MODULE_PAYMENT_WORLDPAY_PREAUTH);				
	if (MODULE_PAYMENT_WORLDPAY_USEPREAUTH == 'True') $process_button_string .= tep_draw_hidden_field(MODULE_PAYMENT_WORLDPAY_PREAUTHACCID, MODULE_PAYMENT_WORLDPAY_PREAUTHID);			
// I'm not sure if this address function works.  Essentially it is meant to concatenate the address of the customer into a single string with fields seperated by "&#10;" without inverted commas.  In my testing it came through as &amp;#10; - not sure if it still works.				
	$address = htmlspecialchars($order->customer['street_address'] . '&#10;' . $order->customer['suburb'] . '&#10;' . $order->customer['city'] . '&#10;' . $order->customer['state'], ENT_QUOTES);
// We need to add back to the string so we add the concatenate dot onto the previous strings same name value
	$process_button_string .=	
// Defines the TestMode value as specified in Admin	
	tep_draw_hidden_field('testMode', MODULE_PAYMENT_WORLDPAY_MODE) .
// Creates the full name of the customer	
	tep_draw_hidden_field('name', $order->customer['firstname'] . ' ' . $order->customer['lastname']) .
// Adds the address string we created above.
	tep_draw_hidden_field('address', $address) .
	tep_draw_hidden_field('postcode', $order->customer['postcode']) .
// Takes the ISO code from the OSC database
	tep_draw_hidden_field('country', $order->customer['country']['iso_code_2']) .
	tep_draw_hidden_field('tel', $order->customer['telephone']) .
    tep_draw_hidden_field('fax', $order->customer['fax']) .
// I don't know why both URL's require going to checkout_process, but I could only get it working if they both are directed to that page.  Creates the URLS as per the strings above.					
    tep_draw_hidden_field('MC_failURL', tep_href_link(FILENAME_CHECKOUT_PROCESS, $worldpay_fail, 'SSL')).
    tep_draw_hidden_field('MC_successURL', tep_href_link(FILENAME_CHECKOUT_PROCESS, $worldpay_success, 'SSL')) .
    tep_draw_hidden_field('email', $order->customer['email_address']) .
// I don't think the line below is required since the session id is already passed in the redirect urls as success or fail.	
	tep_draw_hidden_field(tep_session_name(), tep_session_id());
    return $process_button_string;
    }

  function before_process() {
      global $HTTP_POST_VARS;
// The WorldPay server posts many variables back to your script, but the only one we are interested in is transtatus.  Either WorldPay works, or it gets cancelled - those are the only options.  This section of the script checks the result, and if it doesn't get a successful result, it will return to the payment page with the error message as defined in the worldpay language file which you can customise.
      if ($HTTP_POST_VARS['transStatus'] != 'Y') {
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_WORLDPAY_TEXT_ERROR_MESSAGE), 'SSL', true, false));
      }
    }

    function after_process() {
      return false;
    }

    function output_error() {
      return false;
    }
	
	function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_WORLDPAY_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }
// The install function has been changed quite a bit to allow many more user friendly customized changes within the Admin section.
    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable WorldPay Module', 'MODULE_PAYMENT_WORLDPAY_STATUS', 'True', 'Do you want to accept WorldPay payments?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
	  
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Worldpay Installation ID', 'MODULE_PAYMENT_WORLDPAY_ID', '00000', 'Your WorldPay Select Junior ID', '6', '2', now())");
    
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Mode', 'MODULE_PAYMENT_WORLDPAY_MODE', '100', 'The mode you are working in (100 = Test Mode Accept, 101 = Test Mode Decline, 0 = Live', '6', '3', now())");
		        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Use Pre-Authorisation?', 'MODULE_PAYMENT_WORLDPAY_USEPREAUTH', 'False', 'Do you want to pre-authorise payments? Default=False. You need to request this from WorldPay before using it.', '6', '4', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
				
	 tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Pre-Auth', 'MODULE_PAYMENT_WORLDPAY_PREAUTH', 'A', 'The mode you are working in (A = Pay Now, E = Pre Auth). Ignored if Use PreAuth is False.', '6', '5', now())"); 
	 
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Pre Auth ID', 'MODULE_PAYMENT_WORLDPAY_PREAUTHID', '000000', 'Your Pre-Auth AccID (Get this from WorldPay). Ignored if Use PreAuth is False.', '6', '6', now())");
	 
	 tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Pre Auth AccID', 'MODULE_PAYMENT_WORLDPAY_PREAUTHACCID', 'accId1', 'Your Pre-Auth AccID Account.  Case Sensitive!(Get this from WorldPay). Ignored if Use PreAuth is False.', '6', '7', now())");
	
 
	        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Use MD5', 'MODULE_PAYMENT_WORLDPAY_USEMD5', 'False', 'Use MD5 encyption for transactions?', '6', '8', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
			
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('MD5 secret key', 'MODULE_PAYMENT_WORLDPAY_MD5KEY', '', 'MD5 secret key. Must also be entered into Worldpay installation config', '6', '9', now())");
	  
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_WORLDPAY_STATUS', 'MODULE_PAYMENT_WORLDPAY_ID','MODULE_PAYMENT_WORLDPAY_MODE', 'MODULE_PAYMENT_WORLDPAY_USEPREAUTH', 'MODULE_PAYMENT_WORLDPAY_PREAUTH','MODULE_PAYMENT_WORLDPAY_PREAUTHID','MODULE_PAYMENT_WORLDPAY_PREAUTHACCID','MODULE_PAYMENT_WORLDPAY_USEMD5','MODULE_PAYMENT_WORLDPAY_MD5KEY');
    }
  }
?>
